Package: io.vertx.groovy.core.streams

## [Groovy] Class Pump

- io.vertx.groovy.core.streams.Pump

- Pumps data from a ReadStream to a WriteStream and performs flow control where necessary to prevent the write stream buffer from getting overfull.

  Instances of this class read items from a ReadStream and write them to a WriteStream. If data can be read faster than it can be written this could result in the write queue of the WriteStream growing without bound, eventually causing it to exhaust all available RAM.

  To prevent this, after each write, instances of this class check whether the write queue of the WriteStream is full, and if so, the ReadStream is paused, and a `drainHandler` is set on the WriteStream.

  When the WriteStream has processed half of its backlog, the `drainHandler` will be called, which results in the pump resuming the ReadStream.

  This class can be used to pump from any ReadStream to any WriteStream, e.g. from an HttpServerRequest to an AsyncFile, or from NetSocket to a WebSocket.

  Please see the documentation for more information.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `Pump (java.lang.Object delegate)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `java.lang.Object` | `getDelegate()`
    `int` | `numberPumped()` Return the total number of items pumped by this pump.
    `static Pump` | `pump(ReadStream<T> rs, WriteStream<T> ws)` Create a new `Pump` with the given `ReadStream` and `WriteStream`
    `static Pump` | `pump(ReadStream<T> rs, WriteStream<T> ws, int writeQueueMaxSize)` Create a new `Pump` with the given `ReadStream` and `WriteStream` and `writeQueueMaxSize`
    `Pump` | `setWriteQueueMaxSize(int maxSize)` Set the write queue max size to `maxSize`
    `Pump` | `start()` Start the Pump.
    `Pump` | `stop()` Stop the Pump.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Constructor Detail

    - #### Pump(java.lang.Object delegate)

  - ### Method Detail

    - #### java.lang.Object getDelegate()

    - #### int numberPumped()

      Return the total number of items pumped by this pump.

      Returns:

    - #### static Pump pump(ReadStream<T> rs, WriteStream<T> ws)

      Create a new `Pump` with the given `ReadStream` and `WriteStream`

      Returns:
        the pump
      Parameters:
        `rs` - the read stream
        `ws` - the write stream

    - #### static Pump pump(ReadStream<T> rs, WriteStream<T> ws, int writeQueueMaxSize)

      Create a new `Pump` with the given `ReadStream` and `WriteStream` and `writeQueueMaxSize`

      Returns:
        the pump
      Parameters:
        `rs` - the read stream
        `ws` - the write stream
        `writeQueueMaxSize` - the max size of the write queue

    - #### Pump setWriteQueueMaxSize(int maxSize)

      Set the write queue max size to `maxSize`

      Returns:
        a reference to this, so the API can be used fluently
      Parameters:
        `maxSize` - the max size

    - #### Pump start()

      Start the Pump. The Pump can be started and stopped multiple times.

      Returns:
        a reference to this, so the API can be used fluently

    - #### Pump stop()

      Stop the Pump. The Pump can be started and stopped multiple times.

      Returns:
        a reference to this, so the API can be used fluently